    MODULE quad_1d_inf_ex01_mod

      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Default Accessibility ..
      PUBLIC
      ! .. Intrinsic Functions ..
      INTRINSIC KIND
      ! .. Parameters ..
      INTEGER, PARAMETER :: wp = KIND(1.0D0)

    CONTAINS

      FUNCTION f(x)

        ! .. Implicit None Statement ..
        IMPLICIT NONE
        ! .. Intrinsic Functions ..
        INTRINSIC SIZE, SQRT
        ! .. Array Arguments ..
        REAL (wp), INTENT (IN) :: x(:)
        ! .. Function Return Value ..
        REAL (wp) :: f(SIZE(x))
        ! .. Executable Statements ..
        f = 1.0_wp/((x+1.0_wp)*SQRT(x))

      END FUNCTION f

    END MODULE quad_1d_inf_ex01_mod

    PROGRAM nag_quad_1d_inf_ex01

      ! Example Program Text for nag_quad_1d_inf
      ! NAG fl90, Release 4. NAG Copyright 2000.

      ! .. Use Statements ..
      USE nag_examples_io, ONLY : nag_std_out
      USE nag_quad_1d_inf, ONLY : nag_quad_1d_inf_gen
      USE quad_1d_inf_ex01_mod, ONLY : wp, f
      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Local Scalars ..
      REAL (wp) :: a, result
      CHARACTER (1) :: inf_limit
      ! .. Executable Statements ..
      WRITE (nag_std_out,*) 'Example Program Results for nag_quad_1d_inf_ex01'

      a = 0.0_wp
      inf_limit = 'upper'

      CALL nag_quad_1d_inf_gen(f,a,inf_limit,result)

      WRITE (nag_std_out,'(/,1X,A,F10.4)') &
       'a  - lower limit of integration = ', a
      WRITE (nag_std_out,'(1X,A,A)') &
       'inf_limit  - infinite limit of integration = ', inf_limit
      WRITE (nag_std_out,'(1X,A,F9.5)') &
       'result - approximation to the integral =', result

    END PROGRAM nag_quad_1d_inf_ex01
